# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%global pythonver %(python -c "import sys; print sys.version[:3]" 2>/dev/null || echo none)
%{!?python_sitelib: %global python_sitelib %{_prefix}/lib/python%{pythonver}/site-packages}

Summary:	The "widget" theme for the moin wiki engine
Name:		moin-theme-widget
Version:	20060807
Release:	9.%{__distinit}%{__distvers}
Url:		http://moinmo.in/ThemeMarket/Widget
Source0:	widget.tar.gz
Patch0:		moin-theme-widget-20060807-nobg.patch
Patch1:		widget.py.moin-1.6.0.diff
Patch2:		widget.py.diff
Patch3:		moin-theme-widget-20060807-cli.patch
License:	GPLv2+
Group:		Applications/Internet
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
Requires:	moin > 1.6.0
%if "%{pythonver}" == "2.3"
Requires:	python-abi = 2.3
%else
Requires:	python(abi) = %{pythonver}
%endif
BuildRequires:	python2, symlinks

%description
Inspired by Modern but very different. The left hand sidebar contains a menu,
which is actually the content of another wiki page, so the menu can be edited
simply by editing another wiki page. Arbitrary pre-formatted HTML such as
Google Adsense ads or a Paypal donate button can also be put into a wiki page
and it can be inserted into the theme exactly as it stands. You can also choose
what content you would like displayed on each page (a regexp on the page name
determines which menu/object is displayed). Multiple content blocks can be
pulled into a page if required.

%prep
%setup -q -c

# remove non-existent background image
%patch0 -p1

# moin ≥ 1.6.0 compatibility
%patch1 -p0

# fix subpages
%patch2 -p0

# remove redundant reference to request_cli
%patch3 -p1

cat << EOF > README.rpm
After installing this package, any newly-created wiki instances should
automatically have the widget theme available.

To make the widget theme available to an existing wiki instance, copy
%{_datadir}/moin/data/plugin/theme/widget.py*
to the data/plugin/theme directory of the wiki instance, and copy directories
%{_datadir}/moin/data/pages/site(2f)sidemenu
and
%{_datadir}/moin/data/pages/site(2f)sidemenu(2f)default
to the data/pages directory of the wiki instance, then do:
chown apache:apache /path/to/wiki/data/plugin/theme/widget.py*
chown -R apache:apache /path/to/wiki/data/pages/site*
You may need to restart the web server after doing this.

For information on configuring the sidemenu, see the site/sidemenu page of
the wiki after installing the theme. You may need to use the 'Delete Cache'
action before being able to read/modify the sidemenu pages.
EOF

%build
# Generate normal (.pyc) byte-compiled files.
python -c 'import compileall; compileall.compile_dir(".", 1, "/", 1)'
# Generate optimized (.pyo) byte-compiled files.
python -O -c 'import compileall; compileall.compile_dir(".", 1, "/", 1)'

%install
rm -rf %{buildroot}
install -d -m 755 %{buildroot}%{_datadir}/moin/htdocs/widget/{css,img}
install -d -m 755 %{buildroot}%{_datadir}/moin/data/{pages,plugin/theme}
install -p -m 644 widget/css/*.css	%{buildroot}%{_datadir}/moin/htdocs/widget/css/
install -p -m 644 widget/img/*.png	%{buildroot}%{_datadir}/moin/htdocs/widget/img/
install -p -m 644 widget.py*		%{buildroot}%{_datadir}/moin/data/plugin/theme/
cp -a data/pages/*			%{buildroot}%{_datadir}/moin/data/pages/

# Symlink to conflict and renamed icons from modern theme
ln -s ../../modern/img/moin-{conflict,renamed}.png %{buildroot}%{_datadir}/moin/htdocs/widget/img/

# Symlink to msie.css from modern theme
ln -s ../../modern/css/msie.css %{buildroot}%{_datadir}/moin/htdocs/widget/css/

# Add compat symlink for moin 1.9.0
# (can't do it the other way around as it would break updates)
mkdir -p %{buildroot}%{python_sitelib}/MoinMoin/web/static/htdocs/
ln -s %{buildroot}%{_datadir}/moin/htdocs/widget \
	%{buildroot}%{python_sitelib}/MoinMoin/web/static/htdocs/widget
symlinks -cs %{buildroot}%{python_sitelib}/MoinMoin/web/static/htdocs/

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc README*
%{_datadir}/moin/htdocs/widget/
%{_datadir}/moin/data/pages/site(2f)sidemenu/
%{_datadir}/moin/data/pages/site(2f)sidemenu(2f)default/
%{_datadir}/moin/data/plugin/theme/widget.py*
%{python_sitelib}/MoinMoin/web/static/htdocs/widget

%changelog
* Thu Oct 13 2011 Paul Howarth <paul@city-fan.org> 20060807-9
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux
- BR: python2 rather than just python

* Wed Jul 28 2010 Paul Howarth <paul@city-fan.org> 20060807-8
- Rebuild for python 2.7 in Rawhide

* Wed May 26 2010 Paul Howarth <paul@city-fan.org> 20060807-7
- Fix dist tag for RHEL-6 Beta

* Thu Dec 31 2009 Paul Howarth <paul@city-fan.org> 20060807-6
- Add patch for moin-1.9.0 compatibility, removing reference to request_cli
- Add compat symlink to static content from
  %%{python_sitelib}/MoinMoin/web/static/htdocs for moin >= 1.9.0
- BR: symlinks

* Fri Jul 31 2009 Paul Howarth <paul@city-fan.org> 20060807-5
- Define RPM macros in global scope
- New upstream URL (moin site moved to moinmo.in)
- Use %%{__install} -p to maintain timestamps
- Add patches from upstream website for moin >= 1.6.0 compatibility & subpages
- Require moin >= 1.6.0
- Symlink missing icons for conflict and renamed to those from the modern theme
- Link to msie.css from modern theme

* Tue Nov  6 2007 Paul Howarth <paul@city-fan.org> 20060807-4
- Fix dist tag for Fedora 7 onwards
- Clarify license as GPL version 2 or later

* Mon Dec 11 2006 Paul Howarth <paul@city-fan.org> 20060807-3
- Rebuild for python 2.5 on Rawhide

* Tue Dec  5 2006 Paul Howarth <paul@city-fan.org> 20060807-2
- Fix python-abi dep for python 2.3
- Fix mock build where python is not in the initial buildroot

* Mon Sep 18 2006 Paul Howarth <paul@city-fan.org> 20060807-1
- Update to 20060807 version
- Fix dist tag for development builds
- Buildreq python, not python-devel
- Don't ghost .pyo files

* Wed Jun 14 2006 Paul Howarth <paul@city-fan.org> 20060514-1
- Initial package build
